//	This is the main_driver initialization-function
//	which is processes all Input arguments
//	and sets as defaults all encessary members of main_driver
//


// INCLUDES
#include <iostream.h>
#include <stdlib.h>

//---------------------------------------------

//////////////////////
// Function: int * initialization(int argCount, char **argValues, int &number_dims)
// Description: Init Function dealing with initializing the main_driver at start-up!
// Returns: pointer to the array of dimension-sizes
//////////////////////
int * initialization(int argCount, char **argValues, int &number_dims)
{	int exit_or_not;  // Program exits if = 0, or proceeds for any other value
	int Y_dim = 256, X_dim = 256;		// Dummy default dimensions
	int *dimensions;

	cout << "Number of Input Arguments = " << argCount <<endl;
	for (int i = 0 ; i < argCount; i++)
		cout << "The " << i << "-th argument is " << argValues[i]<<endl;

	// Assume correct call to "main_driver.exe":
	// main_driver.exe InputRawByteFile.img OutputRawByteFile.img
	//					 NumberOfDimensions [SizeOfDiminsion_k]
	if (argCount == 6)	// This is the RIGHT input command line for 2D images
	{	number_dims = atoi(argValues[3]);
		dimensions = new int [number_dims];
		dimensions[0] = atoi(argValues[4]);
		dimensions[1] = atoi(argValues[5]);
	 }
	else { 		// Set dummy dimensions 
				// (THESE MUST BE READ FROM USER'S COMMAND INPUT ARGUMENTS)
		dimensions = new int [2];
		dimensions[0] = X_dim;
		dimensions[1] = Y_dim;
	}

    	cout << "This is a demo Driver Program!!!" << endl;
	cout << "Enter 0 to exit! Enter any other number to proceed!!!" <<endl;
    	cin >> exit_or_not;
	if (exit_or_not==0) exit(0);

	return (dimensions);
}

//----------------------------------------------
